@ECHO off
SET _icheckDir=C:\i-mation\i-checkDB\

:: check admin rights
net session >nul 2>&1
if %errorLevel% NEQ 0 (GOTO NoAdmin)

:: get current path
SET _here=%~d0%~p0%

:: Check if VisionPro is installed
IF NOT DEFINED VPRO_ROOT GOTO no_cognex

:: prepare local install directory to enable installation via network
IF exist "%tmp%\iTool.Install" (RD /s /q "%tmp%\iTool.Install" >NUL)
XCOPY "%_here%iTool.Install" "%tmp%\iTool.Install" /i /s /y /q >NUL

:: Skip serial number generation since it does not work 
goto no_key

CHOICE /t 10 /d n /M "Generate Licence Key File" 
IF errorlevel 2 goto no_key

:: generate LicenseNum.ini file
type NUL > "%tmp%\iTool.Install\bin\LicenseNum.ini"
for /f "tokens=3" %%A in ('cogtool -p ^| find "Serial"') do (
	ECHO Enter Licence Key for Cognex Serial Number %%A
	SET /P _LicKey=Enter Key: 
	ECHO [%%A] >> "%tmp%\iTool.Install\bin\LicenseNum.ini"
	ECHO GEN=%_LicKey% >> "%tmp%\iTool.Install\bin\LicenseNum.ini"
)

:no_key

:: get installation directories
:: VisionPro root
ECHO %VPRO_ROOT%\bin\> "%TMP%\iTool.Install\paths.txt"

:: i-checkDB
IF exist "%_icheckDir%" GOTO icheck
ECHO i-checkDB not found in "%_icheckDir%".
ECHO You need to copy the files manually to the i-ckeckDB path
:icheck
ECHO %_icheckDir%>> "%TMP%\iTool.Install\paths.txt"

:: Designer
:: reg query HKLM\SOFTWARE\COGNEX\Designer >nul 2>&1
:: if %errorLevel% NEQ 0 (GOTO NoDesigner)
:: FOR /f "tokens=2*" %%A IN ('reg query HKLM\SOFTWARE\COGNEX\Designer /s /v Path ^| find "REG_SZ"') do (echo %%B>> "%TMP%\iTool.Install\paths.txt")
SET _designerPluginDir=%ProgramData%\Cognex\Designer\Plugins\Cognex\Cognex ViDi Suite 3.2 Plugin for Designer\
IF not exist "%_designerPluginDir%" goto NoDesigner
ECHO %_designerPluginDir%>> "%TMP%\iTool.Install\paths.txt"
:NoDesigner

:: copy files
ECHO Copying binaries to the following directories:
TYPE "%TMP%\iTool.Install\paths.txt"
FOR /f "tokens=* delims=," %%A IN (%TMP%\iTool.Install\paths.txt) DO (
	XCOPY /I /Q /Y "%tmp%\iTool.Install\bin\*" "%%A"
)
if not exist "%VPRO_ROOT%\bin\Templates\Tools\i-mation Tools" (
	MD "%VPRO_ROOT%\bin\Templates\Tools\i-mation Tools"
)

IF not exist "%_designerPluginDir%" goto NoDesigner2
ECHO Removing duplicate DLLs in Designer Plugin Path
DEL "%_designerPluginDir%Cognex.Diagnostics.dll"
DEL "%_designerPluginDir%Cognex.Logging.NLog.dll"
DEL "%_designerPluginDir%NLog.dll"
:NoDesigner2

ECHO Copying tool templates to %VPRO_ROOT%\bin\Templates\Tools\i-mation Tools
XCOPY /I /Q /Y "%tmp%\iTool.Install\ToolTemplates\*" "%VPRO_ROOT%\bin\Templates\Tools\i-mation Tools"

pause

:: cleanup
RD /s /q %tmp%\iTool.Install >NUL
GOTO:EOF


:no_cognex
ECHO VisionPro not installed on this system
pause
GOTO:EOF

:NoAdmin
ECHO Must be Administrator to run this program
powershell start -verb runas '%0' & exit /b
